diff --git a/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java b/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
index 6dee67e1c..6f4c58628 100644
--- a/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
+++ b/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
@@ -111,9 +111,9 @@ public final class DisplayPos {
         @Override
         public DisplayPos deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
             JsonObject object = json.getAsJsonObject();
-            float[] rotation = GsonHelper.getAsFloatArray(object.get("rotation"), 3);
-            float[] translation = GsonHelper.getAsFloatArray(object.get("translation"), 3);
-            float[] scale = GsonHelper.getAsFloatArray(object.get("scale"), 3);
+            float[] rotation = object.has("rotation") ? GsonHelper.getAsFloatArray(object.get("rotation"), 3) : new float[] { 0, 0, 0 };
+            float[] translation = object.has("translation") ? GsonHelper.getAsFloatArray(object.get("translation"), 3) : new float[] { 0, 0, 0 };
+            float[] scale = object.has("scale") ? GsonHelper.getAsFloatArray(object.get("scale"), 3) : new float[] { 0, 0, 0 };
             return new DisplayPos(
                 translation[0] * BlockModelMojangData.BLOCKS_PER_UNIT, translation[1] * BlockModelMojangData.BLOCKS_PER_UNIT, translation[2] * BlockModelMojangData.BLOCKS_PER_UNIT,
                 rotation[0], rotation[1], rotation[2],
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
index 954aab092..e198d6534 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
@@ -14,6 +14,7 @@ import com.google.gson.stream.JsonReader;
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -114,7 +115,7 @@ public class BlockModelMojangData implements BlockModelData {
         @Nullable final Object2IntMap<@NotNull Direction> particleIndices,
         @Nullable final List<@NotNull Element> elements)
     {
-        this.modelId = id.makePermanent();
+        this.modelId = new NamespaceID(id);
         this.parent = parent;
         if (parent != null) {
             final BlockModelMojangData parentData = BlockModelMojangData.Cache.loadModelData(texturePackList, parent);
@@ -178,7 +179,7 @@ public class BlockModelMojangData implements BlockModelData {
     public static class Builder {
         protected @Nullable String parent = DEFAULT_PARENT;
         protected boolean ambientOcclusion = DEFAULT_AMBIENT_OCCLUSION;
-        protected int renderLayer = DEFAULT_RENDER_LAYER;
+        protected @Nullable Integer renderLayer = null;
         protected @Nullable Map<@NotNull String, @NotNull DisplayPos> displayPosMap = null;
         protected @Nullable Map<@NotNull String, @NotNull String> textures = null;
         protected @Nullable Object2IntMap<@NotNull Direction> particleIndices = null;
@@ -345,6 +346,21 @@ public class BlockModelMojangData implements BlockModelData {
             return model;
         }
 
+        private static @NotNull BlockModelMojangData MISSING_MODEL = new BlockModelMojangData.Builder()
+            .addElement(new Element.Builder(0, 0, 0, 16, 16, 16)
+                .addFace(Direction.UP, new Face.Builder("minecraft:block/missing"))
+                .addFace(Direction.DOWN, new Face.Builder("minecraft:block/missing"))
+                .addFace(Direction.NORTH, new Face.Builder("minecraft:block/missing"))
+                .addFace(Direction.SOUTH, new Face.Builder("minecraft:block/missing"))
+                .addFace(Direction.WEST, new Face.Builder("minecraft:block/missing"))
+                .addFace(Direction.EAST, new Face.Builder("minecraft:block/missing"))
+            )
+            .setAO(true)
+            .build(Minecraft.getMinecraft().texturePackList, "minecraft:block/missing");
+        public static @NotNull BlockModelMojangData getMissingModel() {
+            return MISSING_MODEL;
+        }
+
         public static void resetCache() {
             modelDataCache.clear();
         }
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
index 3bd050f7a..c5a46949c 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
@@ -1,6 +1,7 @@
 package org.useless.dragonfly.data.block.mojang;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.client.render.block.model.BlockModelStandard;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -9,11 +10,16 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2f;
+import org.joml.Vector2fc;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.Vector3f;
+import org.joml.Vector3fc;
 import org.slf4j.Logger;
 import org.useless.dragonfly.DisplayPos;
+import org.useless.dragonfly.data.block.BlockModelData;
 
-import java.util.Arrays;
-import java.util.HashMap;
 import java.util.Map;
 
 import static org.useless.dragonfly.data.block.mojang.BlockModelMojangData.BLOCKS_PER_UNIT;
@@ -23,10 +29,10 @@ public class CompiledBlockModelMojangData {
 
     public final BlockModelMojangData data;
 
-    public final @NotNull Map<@NotNull String, @NotNull IconCoordinate> textures = new HashMap<>();
+    public final @NotNull Map<@NotNull String, IconCoordinate> textures = new Object2ObjectOpenHashMap<>();
     public final @NotNull C_Element @NotNull [] elements;
     public final int @NotNull [] particleIndices;
-    public final @NotNull Map<@NotNull String, @NotNull DisplayPos> displayPosMap;
+    public final @NotNull Map<@NotNull String, DisplayPos> displayPosMap;
     public final int renderLayer;
 
     public CompiledBlockModelMojangData(BlockModelMojangData data) {
@@ -37,62 +43,63 @@ public class CompiledBlockModelMojangData {
         } else {
             for (String key : data.textures.keySet()) {
                 IconCoordinate coordinate = getTexture("#" + key, null, true);
-                if (coordinate != null) textures.put("#" + key, coordinate);
+                if (coordinate != null) this.textures.put("#" + key, coordinate);
             }
         }
 
-        IconCoordinate particleAll = textures.get("#particle");
+        IconCoordinate particleAll = this.textures.get("#particle");
 
         if (particleAll != null) { // Modern mojang format support, the modern mc version only has a global particle texture symbol rather than per side
-            textures.putIfAbsent("#particle_up", particleAll);
-            textures.putIfAbsent("#particle_down", particleAll);
-            textures.putIfAbsent("#particle_north", particleAll);
-            textures.putIfAbsent("#particle_south", particleAll);
-            textures.putIfAbsent("#particle_west", particleAll);
-            textures.putIfAbsent("#particle_east", particleAll);
-            textures.putIfAbsent("#overlay", particleAll);
+            this.textures.putIfAbsent("#particle_up", particleAll);
+            this.textures.putIfAbsent("#particle_down", particleAll);
+            this.textures.putIfAbsent("#particle_north", particleAll);
+            this.textures.putIfAbsent("#particle_south", particleAll);
+            this.textures.putIfAbsent("#particle_west", particleAll);
+            this.textures.putIfAbsent("#particle_east", particleAll);
+            this.textures.putIfAbsent("#overlay", particleAll);
         } else {
-            if (textures.get("#particle_up") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_up' symbol!", data.modelId());
-            if (textures.get("#particle_down") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_down' symbol!", data.modelId());
-            if (textures.get("#particle_north") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_north' symbol!", data.modelId());
-            if (textures.get("#particle_south") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_south' symbol!", data.modelId());
-            if (textures.get("#particle_west") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_west' symbol!", data.modelId());
-            if (textures.get("#particle_east") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_east' symbol!", data.modelId());
+            if (this.textures.get("#particle_up") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_up' symbol!", data.modelId());
+            if (this.textures.get("#particle_down") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_down' symbol!", data.modelId());
+            if (this.textures.get("#particle_north") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_north' symbol!", data.modelId());
+            if (this.textures.get("#particle_south") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_south' symbol!", data.modelId());
+            if (this.textures.get("#particle_west") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_west' symbol!", data.modelId());
+            if (this.textures.get("#particle_east") == null) LOGGER.warn("Model '{}' does not have an assigned '#particle_east' symbol!", data.modelId());
         }
-        if (textures.get("#overlay") == null) LOGGER.warn("Model '{}' does not have an assigned '#overlay' symbol!", data.modelId());
+        if (this.textures.get("#overlay") == null) LOGGER.warn("Model '{}' does not have an assigned '#overlay' symbol!", data.modelId());
 
-        displayPosMap = new HashMap<>();
-        if (data.displayPositions != null) displayPosMap.putAll(data.displayPositions);
+        this.displayPosMap = new Object2ObjectOpenHashMap<>();
+        if (data.displayPositions != null) this.displayPosMap.putAll(data.displayPositions);
 
-        particleIndices = new int[6];
+        this.particleIndices = new int[6];
         if (data.particleIndices != null) {
-            particleIndices[Direction.UP.getId()] = data.particleIndices.getOrDefault(Direction.UP, 0);
-            particleIndices[Direction.DOWN.getId()] = data.particleIndices.getOrDefault(Direction.DOWN, 0);
-            particleIndices[Direction.NORTH.getId()] = data.particleIndices.getOrDefault(Direction.NORTH, 0);
-            particleIndices[Direction.SOUTH.getId()] = data.particleIndices.getOrDefault(Direction.SOUTH, 0);
-            particleIndices[Direction.WEST.getId()] = data.particleIndices.getOrDefault(Direction.WEST, 0);
-            particleIndices[Direction.EAST.getId()] = data.particleIndices.getOrDefault(Direction.EAST, 0);
+            this.particleIndices[Direction.UP.getId()] = data.particleIndices.getOrDefault(Direction.UP, 0);
+            this.particleIndices[Direction.DOWN.getId()] = data.particleIndices.getOrDefault(Direction.DOWN, 0);
+            this.particleIndices[Direction.NORTH.getId()] = data.particleIndices.getOrDefault(Direction.NORTH, 0);
+            this.particleIndices[Direction.SOUTH.getId()] = data.particleIndices.getOrDefault(Direction.SOUTH, 0);
+            this.particleIndices[Direction.WEST.getId()] = data.particleIndices.getOrDefault(Direction.WEST, 0);
+            this.particleIndices[Direction.EAST.getId()] = data.particleIndices.getOrDefault(Direction.EAST, 0);
         }
 
-        renderLayer = data.renderLayer == null ? 0 : data.renderLayer;
+        this.renderLayer = data.renderLayer == null ? 0 : data.renderLayer;
 
-        elements = new C_Element[data.elements == null ? 0 : data.elements.size()];
+        this.elements = new C_Element[data.elements == null ? 0 : data.elements.size()];
         if (data.elements != null) {
             int i = 0;
             for (Element e : data.elements) {
-                elements[i++] = new C_Element(e);
+                this.elements[i] = new C_Element(this, e);
+                i++;
             }
         }
     }
 
     protected IconCoordinate getTexture(@NotNull final String textureSymbol, @Nullable final IconCoordinate defaultCoordinate, final boolean logWarnings) {
         try {
-            if (data.textures == null) {
-                if (logWarnings) LOGGER.warn("Model '{}' does not have assigned texture data!", data.modelId());
+            if (this.data.textures == null) {
+                if (logWarnings) LOGGER.warn("Model '{}' does not have assigned texture data!", this.data.modelId());
                 return defaultCoordinate;
             }
 
-            @Nullable String path = data.textures.get(textureSymbol.startsWith("#") ? textureSymbol.substring(1) : textureSymbol);
+            @Nullable String path = this.data.textures.get(textureSymbol.startsWith("#") ? textureSymbol.substring(1) : textureSymbol);
 
             if (path == null) {
                 if (logWarnings) LOGGER.warn("Texture for symbol '{}' is not assigned to any value!", textureSymbol);
@@ -110,7 +117,7 @@ public class CompiledBlockModelMojangData {
             }
 
         } catch (StackOverflowError stackOverflowError) {
-            LOGGER.error("Recursive texture lookup from symbol '{}' in model '{}'!", textureSymbol, data.modelId());
+            LOGGER.error("Recursive texture lookup from symbol '{}' in model '{}'!", textureSymbol, this.data.modelId());
             return defaultCoordinate;
         }
     }
@@ -121,20 +128,9 @@ public class CompiledBlockModelMojangData {
         public static final int VERTEX_BOTTOM_RIGHT = 2;
         public static final int VERTEX_BOTTOM_LEFT = 1;
 
-        public static final int VERTEX_FLOAT_X = 0;
-        public static final int VERTEX_FLOAT_Y = 1;
-        public static final int VERTEX_FLOAT_Z = 2;
-        public static final int VERTEX_FLOAT_U = 3;
-        public static final int VERTEX_FLOAT_V = 4;
-        public static final int FLOATS_PER_VERTEX = 5;
-
-        public static final int NORMAL_FLOAT_X = 0;
-        public static final int NORMAL_FLOAT_Y = 1;
-        public static final int NORMAL_FLOAT_Z = 2;
-        public static final int FLOATS_PER_NORMAL = 3;
-
         public final int lightEmission;
         public final boolean shade;
+        public final boolean flip;
 
         public final float minX;
         public final float minY;
@@ -144,27 +140,41 @@ public class CompiledBlockModelMojangData {
         public final float maxZ;
 
         public final int faces;
-        public final float @NotNull [] vertexData;
-        public final float @NotNull [] normalData;
+        public final @NotNull Element sourceElement;
+        public final @NotNull Vector3dc @NotNull [] vertexPoses;
+        public final @NotNull Vector2fc @NotNull [] vertexUvs;
+        public final @NotNull Vector3fc @NotNull [] faceNormals;
+        public final @NotNull Vector3fc @NotNull [] faceUps;
+        public final @NotNull Vector3fc @NotNull [] faceLefts;
         public final int @NotNull [] tintIndices;
         public final @Nullable Direction @NotNull [] cullfaces;
         public final @NotNull Direction @NotNull [] directions;
-        public final @NotNull String @NotNull [] textures;
-
-        public C_Element(Element element) {
-            faces = element.faces.size();
-            vertexData = new float[faces * 4 * FLOATS_PER_VERTEX];
-            normalData = new float[faces * FLOATS_PER_NORMAL];
-            tintIndices = new int[faces];
-            cullfaces = new Direction[faces];
-            directions = new Direction[faces];
-            textures = new String[faces];
-
-            shade = element.shade;
-            lightEmission = element.lightEmission;
+        public final @NotNull IconCoordinate @NotNull [] textures;
+
+        public C_Element(@NotNull CompiledBlockModelMojangData data, @NotNull Element element) {
+            this.faces = element.faces.size();
+            this.sourceElement = element;
+            this.vertexPoses = new Vector3dc[this.faces * 4];
+            this.vertexUvs = new Vector2fc[this.faces * 4];
+            this.faceNormals = new Vector3fc[this.faces];
+            this.faceUps = new Vector3fc[this.faces];
+            this.faceLefts = new Vector3fc[this.faces];
+            this.tintIndices = new int[this.faces];
+            this.cullfaces = new Direction[this.faces];
+            this.directions = new Direction[this.faces];
+            this.textures = new IconCoordinate[this.faces];
+
+            this.shade = element.shade;
+            this.lightEmission = element.lightEmission;
+
+            int negs = 0;
+            if (element.fromX > element.toX) negs++;
+            if (element.fromY > element.toY) negs++;
+            if (element.fromZ > element.toZ) negs++;
+            this.flip = (negs & 0b1) != 0;
 
             if (element.rotation != null && element.rotation.rescale) {
-                float x = (45 - Math.abs(((element.rotation.angle + 360) % 360) - 45))/45f;
+                float x = (45 - Math.abs(((element.rotation.angle + 90) % 90) - 45))/45f;
                 float scalar = MathHelper.sqrt_float(1 + x * x);
 
                 float cx = element.rotation.originX * BLOCKS_PER_UNIT;
@@ -173,42 +183,42 @@ public class CompiledBlockModelMojangData {
 
                 switch (element.rotation.axis) {
                     case X:
-                        minX = element.fromX * BLOCKS_PER_UNIT;
-                        minY = (((element.fromY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
-                        minZ = (((element.fromZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
+                        this.minX = element.fromX * BLOCKS_PER_UNIT;
+                        this.minY = (((element.fromY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
+                        this.minZ = (((element.fromZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
 
-                        maxX = element.toX * BLOCKS_PER_UNIT;
-                        maxY = (((element.toY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
-                        maxZ = (((element.toZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
+                        this.maxX = element.toX * BLOCKS_PER_UNIT;
+                        this.maxY = (((element.toY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
+                        this.maxZ = (((element.toZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
                         break;
                     case Y:
-                        minY = element.fromY * BLOCKS_PER_UNIT;
-                        minX = (((element.fromX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
-                        minZ = (((element.fromZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
+                        this.minY = element.fromY * BLOCKS_PER_UNIT;
+                        this.minX = (((element.fromX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
+                        this.minZ = (((element.fromZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
 
-                        maxY = element.toY * BLOCKS_PER_UNIT;
-                        maxX = (((element.toX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
-                        maxZ = (((element.toZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
+                        this.maxY = element.toY * BLOCKS_PER_UNIT;
+                        this.maxX = (((element.toX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
+                        this.maxZ = (((element.toZ * BLOCKS_PER_UNIT) - cz) * scalar) + cz;
                         break;
                     case Z:
                     default:
-                        minZ = element.fromZ * BLOCKS_PER_UNIT;
-                        minX = (((element.fromX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
-                        minY = (((element.fromY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
+                        this.minZ = element.fromZ * BLOCKS_PER_UNIT;
+                        this.minX = (((element.fromX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
+                        this.minY = (((element.fromY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
 
-                        maxZ = element.toZ * BLOCKS_PER_UNIT;
-                        maxX = (((element.toX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
-                        maxY = (((element.toY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
+                        this.maxZ = element.toZ * BLOCKS_PER_UNIT;
+                        this.maxX = (((element.toX * BLOCKS_PER_UNIT) - cx) * scalar) + cx;
+                        this.maxY = (((element.toY * BLOCKS_PER_UNIT) - cy) * scalar) + cy;
                         break;
                 }
             } else {
-                minX = element.fromX * BLOCKS_PER_UNIT;
-                minY = element.fromY * BLOCKS_PER_UNIT;
-                minZ = element.fromZ * BLOCKS_PER_UNIT;
+                this.minX = element.fromX * BLOCKS_PER_UNIT;
+                this.minY = element.fromY * BLOCKS_PER_UNIT;
+                this.minZ = element.fromZ * BLOCKS_PER_UNIT;
 
-                maxX = element.toX * BLOCKS_PER_UNIT;
-                maxY = element.toY * BLOCKS_PER_UNIT;
-                maxZ = element.toZ * BLOCKS_PER_UNIT;
+                this.maxX = element.toX * BLOCKS_PER_UNIT;
+                this.maxY = element.toY * BLOCKS_PER_UNIT;
+                this.maxZ = element.toZ * BLOCKS_PER_UNIT;
             }
 
 
